@use './styles/form-radiobutton.variations' as variations;
@use './styles/form-radiobutton.variables' as *;

:host {
	@include digi-form-radiobutton--variables;

	.digi-form-radiobutton {
		--BACKGROUND--DEFAULT: var(--digi--form-radiobutton--background-color);
		--BORDER-COLOR--DEFAULT: var(--digi--form-radiobutton--border-color);

    position: relative;

		&--primary {
			@include variations.primary;
		}

		&--secondary {
			@include variations.secondary;
		}

		&--error {
			.digi-form-radiobutton__input:not(:checked) ~ .digi-form-radiobutton__label .digi-form-radiobutton__circle {
				@include variations.error;
			}

			.digi-form-radiobutton__input ~ .digi-form-radiobutton__label .digi-form-radiobutton__circle {
				background-color: var(--BACKGROUND--CHECKED);
				border-color: var(--BORDER-COLOR--CHECKED);
				box-shadow: 0 0 0 var(--digi--border-width--primary) var(--digi--form-radiobutton--box-shadow--error);
			}
		}
	}
}

.digi-form-radiobutton__input {
	position: absolute;
	opacity: 0;
	cursor: pointer;
	height: 0;
	width: 0;
	top: 0;
	left: 0;
}

.digi-form-radiobutton__label {
	display: inline-flex;
	align-items: center;
	gap: var(--digi--gutter--icon);
	font-family: var(--digi--global--typography--font-family--default);
	font-size: var(--digi--typography--body--font-size--desktop);
	color: var(--digi--color--text--primary);
	font-weight: var(--digi--typography--body--font-weight--desktop);
	cursor: pointer;

	.digi-form-radiobutton--layout-block & {
		display: flex;
		padding: var(--digi--form-radiobutton--padding--block) var(--digi--form-radiobutton--padding--inline);
		border-radius: var(--digi--border-radius--primary);

		&:hover {
			background-color: var(--digi--form-radiobutton--label--background-color--hover);
		}
	}
}

.digi-form-radiobutton__circle {
  flex-shrink: 0;
  align-self: flex-start;
	cursor: pointer;
	background-color: var(--BACKGROUND--DEFAULT);
	border-color: var(--BORDER-COLOR--DEFAULT);
	border-width: var(--digi--form-radiobutton--border-width);
	border-style: solid;
	height: var(--digi--form-radiobutton--size);
	width: var(--digi--form-radiobutton--size);
	border-radius: var(--digi--form-radiobutton--size);
	position: relative;
}

.digi-form-radiobutton__input:focus-visible ~ .digi-form-radiobutton__label {

	.digi-form-radiobutton__circle {
		box-shadow: var(--digi--form-radiobutton--input--focus--shadow);
	}

	.digi-form-radiobutton--layout-block & {
		box-shadow: none;
		outline: var(--digi--focus-outline);
		background-color: var(--digi--form-radiobutton--label--background-color--hover);
	}
}

.digi-form-radiobutton__input:checked ~ .digi-form-radiobutton__label .digi-form-radiobutton__circle {
	background-color: var(--BACKGROUND--CHECKED);
	border-color: var(--BORDER-COLOR--CHECKED);

	&::after {
		content: '';
		width: var(--digi--form-radiobutton--marker--size);
		height: var(--digi--form-radiobutton--marker--size);
		border-radius: var(--digi--form-radiobutton--marker--size);
		background: var(--digi--form-radiobutton--color--marker);
		position: absolute;
		left: calc(50% - var(--digi--form-radiobutton--marker--size) / 2);
		top: calc(50% - var(--digi--form-radiobutton--marker--size) / 2);
	}
}
